package generics;

interface Stack<T> {
    void push(T e);
    T pop();
    T top();
    boolean isEmpty();
}

class MyStack<T> implements Stack<T> {
    T s[];
    int top;

    MyStack(T s[]) {
        // This one is more preferred
        this.s = s;
        top = -1;
    }

    MyStack(int capacity) {
        s = (T[])new Object[capacity];
        top = -1;
    }

    public void push(T e) {
        s[++top] = e;
    }

    public T pop() {
        return s[top--];
    }

    public boolean isEmpty() {
        return top == -1;
    }

    public T top() {
        return s[top];
    }
}

public class MyGenerics5 {
    public static void main(String args[]) {
        MyStack<String> mss = new MyStack<>(20);
        mss.push("A");
        mss.push("B");
        mss.push("C");
        mss.push("D");
        mss.push("E");
        while (!mss.isEmpty()) {
            System.out.println(mss.pop());
        }
        Integer [] array = new Integer[20];
        MyStack<Integer> msi = new MyStack<>(array);
        msi.push(50);
        msi.push(40);
        msi.push(30);
        msi.push(20);
        msi.push(10);
        while (!msi.isEmpty()) {
            System.out.println(msi.pop());
        }
    }
}


